//-------------------------------------------------------------------------------
// DBDummy
//-------------------------------------------------------------------------------

datablock StaticShapeData(DBDummy : DBObject)
{
   // The category variable determines where the item
   // shows up in the mission editor's creator tree.
   // Path is relative to where the script is executed from.
   category = "Restaurant";
   shapeFile = "~/data/shapes/restaurant/chef/chef.dts";
   bitmap = "";
   reachDist = 4.0;
};

function DBDummy::OnLookAt( %this, %client, %obj ) { DBObject::OnLookAt( %this, %client, %obj ); }
function DBDummy::OnEat( %this, %client, %obj ) { DBObject::OnEat( %this, %client, %obj ); }
function DBDummy::OnSit( %this, %client, %user, %obj ) { DBObject::OnSit( %this, %client, %user, %obj ); }

function DBDummy::onAdd(%this, %obj)
{
   DBObject::OnAdd(%this, %obj); 
   AddListenerToList( $listenerList, %obj );
}

function DBDummy::OnPickup( %this, %client, %user, %obj )
{
   CommandToClient( %client, 'CleanupPopup' );

   COGLOG_STATECHANGE( %client.player, "ATPOS", COGLOG_POS(%client.player.getPosition()) );
   COGLOG_ACTION( %client.player, "PICKUP", %obj );

   SetNarration( %client, "[" @ %client.player.getName() SPC "tried to pick up the" SPC %obj.getDataBlock().noun @ "]" );

   // Play a pickup sound.
   %soundPickup = %user.getDataBlock().soundPickup;
   PlaySound( %soundPickup, %user.getPosition() );
}

function DBDummy::OnTouch( %this, %client, %user, %obj )
{
   COGLOG_STATECHANGE( %client.player, "ATPOS", COGLOG_POS(%client.player.getPosition()) );
   COGLOG_ACTION( %client.player, "TOUCH", %obj );

   CommandToClient( %client, 'ShowDummyGui', %this.note );

   SetNarration( %client, "[" @ %client.player.getName() SPC "touched the" SPC %obj.getDataBlock().noun @ "]" );

   // Play a ding sound.
   %soundDing = "~/data/sound/cogmac/ding.wav";
   PlaySound( %soundDing, %user.getPosition() );
}

function DBDummy::OnGive( %this, %client, %user, %obj, %target, %pos ) { DBDummy::OnTouch( %this, %client, %target, %target ); }

//-------------------------------------------------------------------------------

datablock StaticShapeData(DBChef : DBDummy)
{
   className = "DBDummy";
   shapeFile = "~/data/shapes/restaurant/chef/chef.dts";
   bitmap = "restaurant/data/shapes/restaurant/chef/chef.bmp";
   note = "restaurant/data/interface/chef_note.png";
   reachDist = 8.0;
   noun = "chef";
};

datablock StaticShapeData(DBBartender : DBDummy)
{
   className = "DBDummy";
   shapeFile = "~/data/shapes/restaurant/bartender/bartender.dts";
   bitmap = "restaurant/data/shapes/restaurant/bartender/bartender.bmp";
   note = "restaurant/data/interface/bartender_note.png";
   reachDist = 8.0;
   noun = "bartender";
};
















